<?php



require_once GREEN_ZONE_DIR . 'Forms/GZ_BaseForm.php';
require_once GREEN_ZONE_DIR . 'Forms/GZ_Pager.php';



class GZ_Paginator extends GZ_BaseForm
{
  // PUBLIC
      
  public function __construct( $s_gz, $s_html_id )
  {
    global $_SESSION;
    
    parent::__construct( $s_gz );
    
    $this->pagers = Array();
    $this->total_pages = 1;
    $this->current_page = 1;
    $this->html_id = $s_html_id;
  }
  
  public function AddPager( $new_pager ) { $this->pagers[] = $new_pager; }
  
  public function Display()
  {
    echo '<font size=4>';
    
    /**
     * if the total pages is < 5 
     *   display all the page numbers
     * otherwise
     *   if the current page > 2
     *     draw the back to beginning button
     *   if the current page > 1
     *     draw the back by one button
     *   draw the current page number, not as a link
     *   if the current page < the total pages - 1
     *     draw the forward 1 page button
     *   if the current page < the total pages - 2
     *     draw the foward to the end button
     **/
    
    if( $this->total_pages < 5 )
    {
      // draw the paginator controls
          for( $ind = 1; $ind <= $this->total_pages; $ind ++ )
      {
        if( $ind == $this->current_page )
          echo " <b>$ind</b>";
        else
          echo " <a href=?page=$ind>$ind</a>";
      }
    }
    else
    {
      if( $this->current_page > 1 )
        echo '<a href="?page=1"> |&lt; </a>';
      if( $this->current_page > 2 )
        echo '<a href="?page=' . ($this->current_page - 1) . '"> &lt; </a>';
      if( $this->current_page > 1 )
        echo '<a href="?page=1"> 1 </a>';
      if( $this->current_page > 3 )
        echo '&nbsp;...&nbsp;';
      if( $this->current_page > 2 )
        echo '<a href="?page=' . ($this->current_page - 1) . '"> ' . ($this->current_page-1) . ' </a>';
      echo $this->current_page;
      if( $this->current_page < $this->total_pages - 1 )
        echo '<a href="?page=' . ($this->current_page + 1) . '"> ' . ($this->current_page+1) . ' </a>';
      if( $this->current_page < $this->total_pages - 2 )
        echo '&nbsp;...&nbsp;';
      if( $this->current_page < $this->total_pages )
        echo '<a href="?page=' . $this->total_pages . '"> ' . $this->total_pages . ' </a>';
      if( $this->current_page < $this->total_pages - 1)
        echo '<a href="?page=' . ($this->current_page + 1) . '"> &gt; </a>';
      if( $this->current_page < $this->total_pages )
        echo '<a href="?page=' . $this->total_pages . '"> &gt;| </a>';
    }
    

    echo '<br><br>';
    echo '</font>';
  }
  
  public function CheckCurrentPage()
  {
    if( $this->current_page > $this->total_pages )
      $this->current_page = $this->total_pages;
    if( $this->current_page < 1 )
      $this->current_page = 1;
  }
  
  public function DeterminePageRange()
  {
    // check all the pagers to determine the maximum page range

    $this->total_pages = 0;
    foreach( $this->pagers as $next_pager )
    {
      $next_num_pages = $next_pager->GetNumPages();
      if( $next_num_pages > $this->total_pages )
	$this->total_pages = $next_num_pages;
    }
  }
  
  public function Paginate()
  {
    $this->DeterminePageRange();
    
    $this->CheckCurrentPage();
    
    foreach( $this->pagers as $next_pager )
      $next_pager->SetPage( $this->current_page );
  }
  
  public function SetPage( $s_page )
  {
    global $_SESSION;
    echo 'setting page to ' . $s_page . ' <br>';
    $this->current_page = $s_page;
    
    $this->CheckCurrentPage();
    
    $_SESSION[ $this->html_id . 'CurrentPage' ] = $this->current_page;
  }
  
  public function ReadForm()
  {
    if( isset( $_SESSION[ $this->html_id . 'CurrentPage' ] ) )
      $this->current_page = $_SESSION[ $this->html_id . 'CurrentPage' ];

    if( isset( $this->gz->_GET['page'] ) )
      $this->current_page = $this->gz->_GET['page'];
  }
  
  public function ProcessActions()
  {
    $this->Paginate();
    
    return '';
  }
  
  // PRIVATE
  
  private $pagers;
  private $total_pages;
  private $current_page;
};

?>